/* ■■■■■■■■■■■■■ ARMOSY-2 Example ■■■■■■■■■■■■

ADC Converter 0-10V, MCP3424  

Hardware: ARMOSY-2
Version HW: 2.21
Create: 22.04.2016

   ■■■■■■■■■■■■■ TERMINAL CONNECTION ■■■■■■■■■■■■
63 - IN POWER, VCC min 8V/1A!
64 - IN POWER, -"-
72 - IN+ Voltage 0~10V, CH1
73 - IN- Voltage 0~10V, CH1

*/


// ■ LIBRARY
#include <UTFT.h>   //Driver UTFT
#include <Wire.h>    // Library I2C 
#include <MCP3424.h> // Library ADC MCP3424.h 18bit

// ■ DECLARATIONS
UTFT  myGLCD(ITDB24,38,39,40,41); // RS, WR, CS, REST
extern uint8_t BigFont[]; // UTFT Fonds

MCP3424 adc_mcp(0x6B); // Address 107 DEC, 1101 011 BIN
double value_adc; // Value ADC 
float volt; // Volt IN

// ■■■■■■■■■■■■■ SETUP ■■■■■■■■■■■■

void setup()
{

// ■ UTFT
  myGLCD.InitLCD();               // Initialization LCD              
  myGLCD.clrScr();                // Clear Screen
  myGLCD.fillScr(VGA_WHITE);      // VGA Background Transparency
  myGLCD.setColor(0, 0, 0);       // Black Fonds
  myGLCD.setBackColor(255, 255, 255); // White Background
  myGLCD.setFont(BigFont);        // Select Font 

// ■ HEADER  
  myGLCD.print("ARMOSY2 - SW0006", CENTER, 10);             
  myGLCD.print("www.hwpro.cz", CENTER, 220);             

// ■ I2C
  Wire.begin(); // I2C Start
  
// ■ ADC MCP3424
  adc_mcp.generalCall(GC_RESET);
  adc_mcp.creg[CH1].bits = { GAINx1, SR16B, CONTINUOUS, CH1, 1 }; // Gain, Resolutions 12,14, 16, 18 bits, Type Conv, Channel)
}


// ■■■■■■■■■■■■■ MAIN ■■■■■■■■■■■■

void loop()
{
     ConvStatus Xerr = adc_mcp.read(CH1, value_adc);   // Read Conversion
     volt = value_adc * 5; // Gain Vout/Vin = 0.2, 2V = 10V
     myGLCD.printNumF(value_adc, 4, CENTER, 120);    // Print Value UTFT
     myGLCD.print("V", 220, 120);             
     myGLCD.printNumF(volt, 4, CENTER, 160);    // Print Value UTFT
     myGLCD.print("V", 220, 160);             
}

